--- vcl.orig/unx/gtk/gdi/salnativewidgets-gtk.cxx	2010-06-21 12:34:41.000000000 +0100
+++ vcl/unx/gtk/gdi/salnativewidgets-gtk.cxx	2010-06-21 13:19:37.000000000 +0100
@@ -68,39 +68,45 @@
 class NWPixmapCache;
 struct NWFWidgetData
 {
-    GtkWidget *	gCacheWindow;
-    GtkWidget *	gDumbContainer;
+    GtkWidget * gCacheWindow;
+    GtkWidget * gDumbContainer;
 
-    GtkWidget *	gBtnWidget;
-    GtkWidget *	gRadioWidget;
-    GtkWidget *	gRadioWidgetSibling;
-    GtkWidget *	gCheckWidget;
-    GtkWidget *	gScrollHorizWidget;
-    GtkWidget *	gScrollVertWidget;
-    GtkWidget *	gArrowWidget;
-    GtkWidget *	gDropdownWidget;
-    GtkWidget *	gEditBoxWidget;
-    GtkWidget *	gSpinButtonWidget;
-    GtkWidget *	gNotebookWidget;
-    GtkWidget *	gOptionMenuWidget;
-    GtkWidget *	gComboWidget;
-    GtkWidget *	gScrolledWindowWidget;
-    GtkWidget *  gToolbarWidget;
-    GtkWidget *  gToolbarButtonWidget;
-    GtkWidget *  gToolbarToggleWidget;
-    GtkWidget *  gHandleBoxWidget;
-    GtkWidget *  gMenubarWidget;
-    GtkWidget *  gMenuItemMenubarWidget;
-    GtkWidget *  gMenuWidget;
-    GtkWidget *  gMenuItemMenuWidget;
-    GtkWidget *  gMenuItemCheckMenuWidget;
-    GtkWidget *  gMenuItemRadioMenuWidget;
-    GtkWidget *  gImageMenuItem;
-    GtkWidget *  gTooltipPopup;
-    GtkWidget *  gProgressBar;
-    GtkWidget *  gTreeView;
-    GtkWidget *  gHScale;
-    GtkWidget *  gVScale;
+    GtkWidget * gBtnWidget;
+    GtkWidget * gRadioWidget;
+    GtkWidget * gRadioWidgetSibling;
+    GtkWidget * gCheckWidget;
+    GtkWidget * gScrollHorizWidget;
+    GtkWidget * gScrollVertWidget;
+    GtkWidget * gArrowWidget;
+    GtkWidget * gDropdownWidget;
+    GtkWidget * gEditBoxWidget;
+    GtkWidget * gSpinButtonWidget;
+    GtkWidget * gNotebookWidget;
+    GtkWidget * gComboBoxEntryWidget;
+    GtkWidget * gComboBoxEntry_EntryWidget;
+    GtkWidget * gComboBoxEntry_ButtonWidget;
+    GtkWidget * gComboBoxEntry_ArrowWidget;
+    GtkWidget * gComboBoxWidget;
+    GtkWidget * gComboBox_ButtonWidget;
+    GtkWidget * gComboBox_SeparatorWidget;
+    GtkWidget * gComboBox_ArrowWidget;
+    GtkWidget * gScrolledWindowWidget;
+    GtkWidget * gToolbarWidget;
+    GtkWidget * gToolbarButtonWidget;
+    GtkWidget * gToolbarToggleWidget;
+    GtkWidget * gHandleBoxWidget;
+    GtkWidget * gMenubarWidget;
+    GtkWidget * gMenuItemMenubarWidget;
+    GtkWidget * gMenuWidget;
+    GtkWidget * gMenuItemMenuWidget;
+    GtkWidget * gMenuItemCheckMenuWidget;
+    GtkWidget * gMenuItemRadioMenuWidget;
+    GtkWidget * gImageMenuItem;
+    GtkWidget * gTooltipPopup;
+    GtkWidget * gProgressBar;
+    GtkWidget * gTreeView;
+    GtkWidget * gHScale;
+    GtkWidget * gVScale;
 
     NWPixmapCacheList* gNWPixmapCacheList;
     NWPixmapCache* gCacheTabItems;
@@ -120,8 +126,14 @@
         gEditBoxWidget( NULL ),
         gSpinButtonWidget( NULL ),
         gNotebookWidget( NULL ),
-        gOptionMenuWidget( NULL ),
-        gComboWidget( NULL ),
+        gComboBoxEntryWidget( NULL ),
+        gComboBoxEntry_EntryWidget( NULL ),
+        gComboBoxEntry_ButtonWidget( NULL ),
+        gComboBoxEntry_ArrowWidget( NULL ),
+        gComboBoxWidget( NULL ),
+        gComboBox_ButtonWidget( NULL ),
+        gComboBox_SeparatorWidget( NULL ),
+        gComboBox_ArrowWidget( NULL ),
         gScrolledWindowWidget( NULL ),
         gToolbarWidget( NULL ),
         gToolbarButtonWidget( NULL ),
@@ -148,29 +160,29 @@
 // Keep a hash table of Widgets->default flags so that we can
 // easily and quickly reset each to a default state before using
 // them
-static std::hash_map<long, guint>	gWidgetDefaultFlags;
+static std::hash_map<long, guint>   gWidgetDefaultFlags;
 static std::vector<NWFWidgetData>   gWidgetData;
 
-static const GtkBorder aDefDefBorder		= { 1, 1, 1, 1 };
+static const GtkBorder aDefDefBorder        = { 1, 1, 1, 1 };
 
 // Some GTK defaults
-#define MIN_ARROW_SIZE					11
-#define BTN_CHILD_SPACING				1
-#define MIN_SPIN_ARROW_WIDTH				6
-
-
-static void NWEnsureGTKRadio			( int nScreen );
-static void NWEnsureGTKButton			( int nScreen );
-static void NWEnsureGTKCheck			( int nScreen );
-static void NWEnsureGTKScrollbars		( int nScreen );
-static void NWEnsureGTKArrow			( int nScreen );
-static void NWEnsureGTKEditBox			( int nScreen );
-static void NWEnsureGTKSpinButton		( int nScreen );
-static void NWEnsureGTKNotebook			( int nScreen );
-static void NWEnsureGTKOptionMenu		( int nScreen );
-static void NWEnsureGTKCombo			( int nScreen );
-static void NWEnsureGTKScrolledWindow	( int nScreen );
-static void NWEnsureGTKToolbar			( int nScreen );
+#define MIN_ARROW_SIZE                  11
+#define BTN_CHILD_SPACING               1
+#define MIN_SPIN_ARROW_WIDTH                6
+
+
+static void NWEnsureGTKRadio            ( int nScreen );
+static void NWEnsureGTKButton           ( int nScreen );
+static void NWEnsureGTKCheck            ( int nScreen );
+static void NWEnsureGTKScrollbars       ( int nScreen );
+static void NWEnsureGTKArrow            ( int nScreen );
+static void NWEnsureGTKEditBox          ( int nScreen );
+static void NWEnsureGTKSpinButton       ( int nScreen );
+static void NWEnsureGTKNotebook         ( int nScreen );
+static void NWEnsureGTKComboBoxEntry    ( int nScreen );
+static void NWEnsureGTKComboBox         ( int nScreen );
+static void NWEnsureGTKScrolledWindow   ( int nScreen );
+static void NWEnsureGTKToolbar          ( int nScreen );
 static void NWEnsureGTKMenubar          ( int nScreen );
 static void NWEnsureGTKMenu             ( int nScreen );
 static void NWEnsureGTKTooltip          ( int nScreen );
@@ -210,14 +222,10 @@
 							ControlState nState, const ImplControlValue& aValue,
 							const OUString& rCaption );
 //---
-static Rectangle NWGetComboBoxButtonRect( int nScreen, ControlType nType, ControlPart nPart, Rectangle aAreaRect, ControlState nState,
-							const ImplControlValue& aValue, const OUString& rCaption );
-
-//---
-static Rectangle NWGetListBoxButtonRect( int nScreen, ControlType nType, ControlPart nPart, Rectangle aAreaRect, ControlState nState,
-							const ImplControlValue& aValue, const OUString& rCaption );
+static Rectangle NWGetComboBoxEntryButtonRect( int nScreen, ControlType nType, ControlPart nPart, Rectangle aAreaRect, ControlState nState,
+                            const ImplControlValue& aValue, const OUString& rCaption );
 
-static Rectangle NWGetListBoxIndicatorRect( int nScreen, ControlType nType, ControlPart nPart, Rectangle aAreaRect, ControlState nState,
+static Rectangle NWGetComboBoxButtonRect( int nScreen, ControlType nType, ControlPart nPart, Rectangle aAreaRect, ControlState nState,
 							const ImplControlValue& aValue, const OUString& rCaption );
 
 static Rectangle NWGetToolbarRect( int nScreen,
@@ -229,9 +237,9 @@
                                    const OUString& rCaption );
 //---
 
-static Rectangle NWGetScrollButtonRect(	int nScreen, ControlPart nPart, Rectangle aAreaRect );
+static Rectangle NWGetScrollButtonRect( int nScreen, ControlPart nPart, Rectangle aAreaRect );
 //---
-								
+                                
 /*********************************************************
  * PixmapCache
  *********************************************************/
@@ -298,7 +306,6 @@
         g_object_ref( m_pixmap );
 }
 
-
 NWPixmapCache::NWPixmapCache( int nScreen )
 {
     m_idx = 0;
@@ -308,25 +315,25 @@
     if( gWidgetData[m_screen].gNWPixmapCacheList )
         gWidgetData[m_screen].gNWPixmapCacheList->AddCache(this);
 } 
+
 NWPixmapCache::~NWPixmapCache()
 {
     if( gWidgetData[m_screen].gNWPixmapCacheList )
         gWidgetData[m_screen].gNWPixmapCacheList->RemoveCache(this);
     delete[] pData;
 }
+
 void NWPixmapCache::ThemeChanged()
 {
     // throw away cached pixmaps
-    int i;
-    for(i=0; i<m_size; i++)
+    for(int i=0; i<m_size; i++)
         pData[i].SetPixmap( NULL );
 }
 
-BOOL  NWPixmapCache::Find( ControlType aType, ControlState aState, const Rectangle& r_pixmapRect, GdkPixmap** pPixmap )
+BOOL NWPixmapCache::Find( ControlType aType, ControlState aState, const Rectangle& r_pixmapRect, GdkPixmap** pPixmap )
 {
     aState &= ~CTRL_CACHING_ALLOWED; // mask clipping flag
-    int i;
-    for(i=0; i<m_size; i++)
+    for(int i=0; i<m_size; i++)
     {
         if( pData[i].m_nType == aType &&
             pData[i].m_nState == aState &&    
@@ -354,11 +361,11 @@
     pData[m_idx].SetPixmap( pPixmap );
 }
 
-
 void NWPixmapCacheList::AddCache( NWPixmapCache* pCache )
 {
     mCaches.push_back( pCache );
 }
+
 void NWPixmapCacheList::RemoveCache( NWPixmapCache* pCache )
 {
     ::std::vector< NWPixmapCache* >::iterator p;
@@ -366,6 +373,7 @@
     if( p != mCaches.end() )
         mCaches.erase( p );
 }
+
 void NWPixmapCacheList::ThemeChanged( )
 {
     ::std::vector< NWPixmapCache* >::iterator p = mCaches.begin();
@@ -382,10 +390,10 @@
  *********************************************************/
 inline void NW_gtk_border_set_from_border( GtkBorder& aDst, const GtkBorder * pSrc )
 {
-	aDst.left		= pSrc->left;
-	aDst.top		= pSrc->top;
-	aDst.right	= pSrc->right;
-	aDst.bottom	= pSrc->bottom;
+    aDst.left       = pSrc->left;
+    aDst.top        = pSrc->top;
+    aDst.right  = pSrc->right;
+    aDst.bottom = pSrc->bottom;
 }
 
 
@@ -535,41 +543,41 @@
  */
 BOOL GtkSalGraphics::IsNativeControlSupported( ControlType nType, ControlPart nPart )
 {
-	if (
-		((nType==CTRL_PUSHBUTTON)  && (nPart==PART_ENTIRE_CONTROL)) 	||
- 		((nType==CTRL_RADIOBUTTON) && (nPart==PART_ENTIRE_CONTROL))		||
-		((nType==CTRL_CHECKBOX)    && (nPart==PART_ENTIRE_CONTROL))		||
-		((nType==CTRL_SCROLLBAR) &&
-				(  (nPart==PART_DRAW_BACKGROUND_HORZ)
-				|| (nPart==PART_DRAW_BACKGROUND_VERT)
-				|| (nPart==PART_ENTIRE_CONTROL)
-                || (nPart==HAS_THREE_BUTTONS) )  				)	||
-		((nType==CTRL_EDITBOX) &&
-				(  (nPart==PART_ENTIRE_CONTROL)
-				|| (nPart==HAS_BACKGROUND_TEXTURE) ) 			)	||
-		((nType==CTRL_MULTILINE_EDITBOX) &&
-				(  (nPart==PART_ENTIRE_CONTROL)
-				|| (nPart==HAS_BACKGROUND_TEXTURE) ) 			)	||
-		((nType==CTRL_SPINBOX) &&
-				(  (nPart==PART_ENTIRE_CONTROL)
-				|| (nPart==PART_ALL_BUTTONS)
-				|| (nPart==HAS_BACKGROUND_TEXTURE) )			)	||
-		((nType==CTRL_SPINBUTTONS) &&
-				(  (nPart==PART_ENTIRE_CONTROL)
-				|| (nPart==PART_ALL_BUTTONS)	)				)	||
-		((nType==CTRL_COMBOBOX) &&
-				(  (nPart==PART_ENTIRE_CONTROL)
-				|| (nPart==HAS_BACKGROUND_TEXTURE)	)			)	||
-		(((nType==CTRL_TAB_ITEM) || (nType==CTRL_TAB_PANE) ||
-		  (nType==CTRL_TAB_BODY) || (nType==CTRL_FIXEDBORDER)) &&
-				(  (nPart==PART_ENTIRE_CONTROL)
-				|| (nPart==PART_TABS_DRAW_RTL) )				)	||
-		((nType==CTRL_LISTBOX) &&
-				(  (nPart==PART_ENTIRE_CONTROL)
-				|| (nPart==PART_WINDOW)
-				|| (nPart==HAS_BACKGROUND_TEXTURE) )			)   ||
+    if (
+        ((nType==CTRL_PUSHBUTTON)  && (nPart==PART_ENTIRE_CONTROL))     ||
+        ((nType==CTRL_RADIOBUTTON) && (nPart==PART_ENTIRE_CONTROL))     ||
+        ((nType==CTRL_CHECKBOX)    && (nPart==PART_ENTIRE_CONTROL))     ||
+        ((nType==CTRL_SCROLLBAR) &&
+                (  (nPart==PART_DRAW_BACKGROUND_HORZ)
+                || (nPart==PART_DRAW_BACKGROUND_VERT)
+                || (nPart==PART_ENTIRE_CONTROL)
+                || (nPart==HAS_THREE_BUTTONS) )                 )   ||
+        ((nType==CTRL_EDITBOX) &&
+                (  (nPart==PART_ENTIRE_CONTROL)
+                || (nPart==HAS_BACKGROUND_TEXTURE) )            )   ||
+        ((nType==CTRL_MULTILINE_EDITBOX) &&
+                (  (nPart==PART_ENTIRE_CONTROL)
+                || (nPart==HAS_BACKGROUND_TEXTURE) )            )   ||
+        ((nType==CTRL_SPINBOX) &&
+                (  (nPart==PART_ENTIRE_CONTROL)
+                || (nPart==PART_ALL_BUTTONS)
+                || (nPart==HAS_BACKGROUND_TEXTURE) )            )   ||
+        ((nType==CTRL_SPINBUTTONS) &&
+                (  (nPart==PART_ENTIRE_CONTROL)
+                || (nPart==PART_ALL_BUTTONS)    )               )   ||
+        ((nType==CTRL_COMBOBOX) &&
+                (  (nPart==PART_ENTIRE_CONTROL)
+                || (nPart==HAS_BACKGROUND_TEXTURE)  )           )   ||
+        (((nType==CTRL_TAB_ITEM) || (nType==CTRL_TAB_PANE) ||
+          (nType==CTRL_TAB_BODY) || (nType==CTRL_FIXEDBORDER)) &&
+                (  (nPart==PART_ENTIRE_CONTROL)
+                || (nPart==PART_TABS_DRAW_RTL) )                )   ||
+        ((nType==CTRL_LISTBOX) &&
+                (  (nPart==PART_ENTIRE_CONTROL)
+                || (nPart==PART_WINDOW)
+                || (nPart==HAS_BACKGROUND_TEXTURE) )            )   ||
         ((nType == CTRL_TOOLBAR) &&
-         		(	(nPart==PART_ENTIRE_CONTROL)
+                (   (nPart==PART_ENTIRE_CONTROL)
                 ||  (nPart==PART_DRAW_BACKGROUND_HORZ)
                 ||  (nPart==PART_DRAW_BACKGROUND_VERT)
                 ||  (nPart==PART_THUMB_HORZ)
@@ -600,9 +608,9 @@
                 )
         )
         )
-		return( TRUE );
+        return( TRUE );
 
-	return( FALSE );
+    return( FALSE );
 }
 
 
@@ -635,10 +643,10 @@
         gboolean has_backward;
         gboolean has_backward2;
         
-	    gtk_widget_style_get( gWidgetData[m_nScreen].gScrollHorizWidget, "has-forward-stepper", &has_forward,
-									    "has-secondary-forward-stepper", &has_forward2,
-									    "has-backward-stepper", &has_backward,
-	   								    "has-secondary-backward-stepper", &has_backward2, (char *)NULL );
+        gtk_widget_style_get( gWidgetData[m_nScreen].gScrollHorizWidget, "has-forward-stepper", &has_forward,
+                                        "has-secondary-forward-stepper", &has_forward2,
+                                        "has-backward-stepper", &has_backward,
+                                        "has-secondary-backward-stepper", &has_backward2, (char *)NULL );
         Rectangle aForward;
         Rectangle aBackward;
 
@@ -705,14 +713,14 @@
     }
 
     if( IsNativeControlSupported(nType, nPart) )
-	{
-		rIsInside = rControlRegion.IsInside( aPos );
-		return( TRUE );
-	}
-	else
-	{
-		return( FALSE );
-	}
+    {
+        rIsInside = rControlRegion.IsInside( aPos );
+        return( TRUE );
+    }
+    else
+    {
+        return( FALSE );
+    }
 }
 
 
@@ -738,8 +746,8 @@
         return drawNativeMixedStateCheck( nType, nPart, rControlRegion, nState, aValue, rCaption );
     }
 
-	BOOL			returnVal = FALSE;
-	// get a GC with current clipping region set
+    BOOL            returnVal = FALSE;
+    // get a GC with current clipping region set
     SelectFont();
     
     
@@ -828,12 +836,9 @@
     {
         returnVal = NWPaintGTKSpinBox( nType, nPart, aCtrlRect, aClip, nState, aValue, rCaption );
     }
-    else if ( (nType == CTRL_COMBOBOX) &&
-        ( (nPart==PART_ENTIRE_CONTROL)
-        ||(nPart==PART_BUTTON_DOWN)
-        ) )
+    else if ( (nType == CTRL_COMBOBOX) && ((nPart==PART_ENTIRE_CONTROL) || (nPart==PART_BUTTON_DOWN)) )
     {
-        returnVal = NWPaintGTKComboBox( gdkDrawable, nType, nPart, aCtrlRect, aClip, nState, aValue, rCaption );
+        returnVal = NWPaintGTKComboBoxEntry( gdkDrawable, nType, nPart, aCtrlRect, aClip, nState, aValue, rCaption );
     }
     else if ( (nType==CTRL_TAB_ITEM) || (nType==CTRL_TAB_PANE) || (nType==CTRL_TAB_BODY) || (nType==CTRL_FIXEDBORDER) )
     {
@@ -844,7 +849,7 @@
     }
     else if ( (nType==CTRL_LISTBOX) && ((nPart==PART_ENTIRE_CONTROL) || (nPart==PART_WINDOW)) )
     {
-        returnVal = NWPaintGTKListBox( gdkDrawable, nType, nPart, aCtrlRect, aClip, nState, aValue, rCaption );
+        returnVal = NWPaintGTKComboBox( gdkDrawable, nType, nPart, aCtrlRect, aClip, nState, aValue, rCaption );
     }
     else if ( (nType== CTRL_TOOLBAR) )
     {
@@ -961,7 +966,7 @@
 								const ImplControlValue&,
 								const OUString& )
 {
-	return( FALSE );
+    return( FALSE );
 }
 
 
@@ -1001,7 +1006,7 @@
     }
     if ( (nType==CTRL_COMBOBOX) && ((nPart==PART_BUTTON_DOWN) || (nPart==PART_SUB_EDIT)) )
     {
-        rNativeBoundingRegion = NWGetComboBoxButtonRect( m_nScreen, nType, nPart, rControlRegion, nState,
+        rNativeBoundingRegion = NWGetComboBoxEntryButtonRect( m_nScreen, nType, nPart, rControlRegion, nState,
         aValue, rCaption );
         rNativeContentRegion = rNativeBoundingRegion;
         
@@ -1018,7 +1023,7 @@
     }
     if ( (nType==CTRL_LISTBOX) && ((nPart==PART_BUTTON_DOWN) || (nPart==PART_SUB_EDIT)) )
     {
-        rNativeBoundingRegion = NWGetListBoxButtonRect( m_nScreen, nType, nPart, rControlRegion, nState,
+        rNativeBoundingRegion = NWGetComboBoxButtonRect( m_nScreen, nType, nPart, rControlRegion, nState,
         aValue, rCaption );
         rNativeContentRegion = rNativeBoundingRegion;
         
@@ -1134,7 +1139,7 @@
         returnVal = TRUE;
     }
         
-	return( returnVal );
+    return( returnVal );
 }
 
 
@@ -1144,67 +1149,67 @@
 BOOL GtkSalGraphics::NWPaintGTKButton(
             GdkDrawable* gdkDrawable,
             ControlType, ControlPart,
-			const Rectangle& rControlRectangle,            
+            const Rectangle& rControlRectangle,            
             const clipList& rClipList,
             ControlState nState, const ImplControlValue&,
 			const OUString& )
 {
-	GtkStateType	stateType;
-	GtkShadowType	shadowType;
-	gboolean		interiorFocus;
-	gint			focusWidth;
-	gint			focusPad;
-	BOOL			bDrawFocus = TRUE;
-	gint			x, y, w, h;
-	GtkBorder		aDefBorder;
-	GtkBorder*		pBorder;
-    GdkRectangle	clipRect;
+    GtkStateType    stateType;
+    GtkShadowType   shadowType;
+    gboolean        interiorFocus;
+    gint            focusWidth;
+    gint            focusPad;
+    BOOL            bDrawFocus = TRUE;
+    gint            x, y, w, h;
+    GtkBorder       aDefBorder;
+    GtkBorder*      pBorder;
+    GdkRectangle    clipRect;
     
-	NWEnsureGTKButton( m_nScreen );
-	NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
+    NWEnsureGTKButton( m_nScreen );
+    NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
 
-	x = rControlRectangle.Left();
+    x = rControlRectangle.Left();
     y = rControlRectangle.Top();
-	w = rControlRectangle.GetWidth();
-	h = rControlRectangle.GetHeight();
+    w = rControlRectangle.GetWidth();
+    h = rControlRectangle.GetHeight();
 
-	// Grab some button style attributes
-	gtk_widget_style_get( gWidgetData[m_nScreen].gBtnWidget,	"focus-line-width",	&focusWidth,
-								"focus-padding", 	&focusPad,
-					 			"interior_focus",	&interiorFocus,
-								"default_border",	&pBorder,
-								(char *)NULL );
+    // Grab some button style attributes
+    gtk_widget_style_get( gWidgetData[m_nScreen].gBtnWidget,    "focus-line-width", &focusWidth,
+                                "focus-padding",    &focusPad,
+                                "interior_focus",   &interiorFocus,
+                                "default_border",   &pBorder,
+                                (char *)NULL );
 
-	// Make sure the border values exist, otherwise use some defaults
-	if ( pBorder )
-	{
-		NW_gtk_border_set_from_border( aDefBorder, pBorder );
-		gtk_border_free( pBorder );
-	}
-	else NW_gtk_border_set_from_border( aDefBorder, &aDefDefBorder );
+    // Make sure the border values exist, otherwise use some defaults
+    if ( pBorder )
+    {
+        NW_gtk_border_set_from_border( aDefBorder, pBorder );
+        gtk_border_free( pBorder );
+    }
+    else NW_gtk_border_set_from_border( aDefBorder, &aDefDefBorder );
 
-	// If the button is too small, don't ever draw focus or grab more space
-	if ( (w < 16) || (h < 16) )
-		bDrawFocus = FALSE;
+    // If the button is too small, don't ever draw focus or grab more space
+    if ( (w < 16) || (h < 16) )
+        bDrawFocus = FALSE;
 
-	NWSetWidgetState( gWidgetData[m_nScreen].gBtnWidget, nState, stateType );
+    NWSetWidgetState( gWidgetData[m_nScreen].gBtnWidget, nState, stateType );
 
     gint xi = x, yi = y, wi = w, hi = h;
-	if ( (nState & CTRL_STATE_DEFAULT) && bDrawFocus )
-	{
-		xi += aDefBorder.left;
-		yi += aDefBorder.top;
-		wi -= aDefBorder.left + aDefBorder.right;
-		hi -= aDefBorder.top + aDefBorder.bottom;
-	}
+    if ( (nState & CTRL_STATE_DEFAULT) && bDrawFocus )
+    {
+        xi += aDefBorder.left;
+        yi += aDefBorder.top;
+        wi -= aDefBorder.left + aDefBorder.right;
+        hi -= aDefBorder.top + aDefBorder.bottom;
+    }
 
-	if ( !interiorFocus && bDrawFocus )
-	{
-		xi += focusWidth + focusPad;
-		yi += focusWidth + focusPad;
-		wi -= 2 * (focusWidth + focusPad);
-		hi -= 2 * (focusWidth + focusPad);
-	}
+    if ( !interiorFocus && bDrawFocus )
+    {
+        xi += focusWidth + focusPad;
+        yi += focusWidth + focusPad;
+        wi -= 2 * (focusWidth + focusPad);
+        hi -= 2 * (focusWidth + focusPad);
+    }
 
     for( clipList::const_iterator it = rClipList.begin(); it != rClipList.end(); ++it)
     {
@@ -1225,88 +1230,88 @@
         
         if ( (GTK_BUTTON(gWidgetData[m_nScreen].gBtnWidget)->relief != GTK_RELIEF_NONE)
             || (nState & CTRL_STATE_PRESSED)
-		    || (nState & CTRL_STATE_ROLLOVER) )
+            || (nState & CTRL_STATE_ROLLOVER) )
         {
             gtk_paint_box( gWidgetData[m_nScreen].gBtnWidget->style, gdkDrawable, stateType, shadowType,
                            &clipRect, gWidgetData[m_nScreen].gBtnWidget, "button", xi, yi, wi, hi );
         }
     }
 #if 0 // VCL draws focus rects
-	// Draw focus rect
-	if ( (nState & CTRL_STATE_FOCUSED) && (nState & CTRL_STATE_ENABLED) && bDrawFocus )
-	{
-		if (interiorFocus)
-		{
-			x += gWidgetData[m_nScreen].gBtnWidget->style->xthickness + focusPad;
-			y += gWidgetData[m_nScreen].gBtnWidget->style->ythickness + focusPad;
-			w -= 2 * (gWidgetData[m_nScreen].gBtnWidget->style->xthickness + focusPad);
-			h -=  2 * (gWidgetData[m_nScreen].gBtnWidget->style->xthickness + focusPad);
-		}
-		else
-		{
-			x -= focusWidth + focusPad;
-			y -= focusWidth + focusPad;
-			w += 2 * (focusWidth + focusPad);
-			h += 2 * (focusWidth + focusPad);
-		}
-		if ( !interiorFocus )
-			gtk_paint_focus( gWidgetData[m_nScreen].gBtnWidget->style, gdkDrawable, stateType, &clipRect,
+    // Draw focus rect
+    if ( (nState & CTRL_STATE_FOCUSED) && (nState & CTRL_STATE_ENABLED) && bDrawFocus )
+    {
+        if (interiorFocus)
+        {
+            x += gWidgetData[m_nScreen].gBtnWidget->style->xthickness + focusPad;
+            y += gWidgetData[m_nScreen].gBtnWidget->style->ythickness + focusPad;
+            w -= 2 * (gWidgetData[m_nScreen].gBtnWidget->style->xthickness + focusPad);
+            h -=  2 * (gWidgetData[m_nScreen].gBtnWidget->style->xthickness + focusPad);
+        }
+        else
+        {
+            x -= focusWidth + focusPad;
+            y -= focusWidth + focusPad;
+            w += 2 * (focusWidth + focusPad);
+            h += 2 * (focusWidth + focusPad);
+        }
+        if ( !interiorFocus )
+            gtk_paint_focus( gWidgetData[m_nScreen].gBtnWidget->style, gdkDrawable, stateType, &clipRect,
                              gWidgetData[m_nScreen].gBtnWidget, "button", x, y, w, h );
-	}
+    }
 #endif
 
-	return( TRUE );
+    return( TRUE );
 }
 
 static Rectangle NWGetButtonArea( int nScreen,
                                   ControlType, ControlPart, Rectangle aAreaRect, ControlState nState,
 							      const ImplControlValue&, const OUString& )
 {
-	gboolean		interiorFocus;
-	gint			focusWidth;
-	gint			focusPad;
-	GtkBorder		aDefBorder;
-	GtkBorder *	pBorder;
-	BOOL			bDrawFocus = TRUE;
-	Rectangle		aRect;
-	gint			x, y, w, h;
-
-	NWEnsureGTKButton( nScreen );
-	gtk_widget_style_get( gWidgetData[nScreen].gBtnWidget,
-                            	"focus-line-width",	&focusWidth,
-								"focus-padding", 	&focusPad,
-					 			"interior_focus",	&interiorFocus,
-								"default_border",	&pBorder,
-								(char *)NULL );
-
-	// Make sure the border values exist, otherwise use some defaults
-	if ( pBorder )
-	{
-		NW_gtk_border_set_from_border( aDefBorder, pBorder );
-		gtk_border_free( pBorder );
-	}
-	else NW_gtk_border_set_from_border( aDefBorder, &aDefDefBorder );
-
-	x = aAreaRect.Left();
-	y = aAreaRect.Top();
-	w = aAreaRect.GetWidth();
-	h = aAreaRect.GetHeight();
-
-	// If the button is too small, don't ever draw focus or grab more space
-	if ( (w < 16) || (h < 16) )
-		bDrawFocus = FALSE;
-
-	if ( (nState & CTRL_STATE_DEFAULT) && bDrawFocus )
-	{
-		x -= aDefBorder.left;
-		y -= aDefBorder.top;
-		w += aDefBorder.left + aDefBorder.right;
-		h += aDefBorder.top + aDefBorder.bottom;
-	}
+    gboolean        interiorFocus;
+    gint            focusWidth;
+    gint            focusPad;
+    GtkBorder       aDefBorder;
+    GtkBorder * pBorder;
+    BOOL            bDrawFocus = TRUE;
+    Rectangle       aRect;
+    gint            x, y, w, h;
+
+    NWEnsureGTKButton( nScreen );
+    gtk_widget_style_get( gWidgetData[nScreen].gBtnWidget,
+                                "focus-line-width", &focusWidth,
+                                "focus-padding",    &focusPad,
+                                "interior_focus",   &interiorFocus,
+                                "default_border",   &pBorder,
+                                (char *)NULL );
+
+    // Make sure the border values exist, otherwise use some defaults
+    if ( pBorder )
+    {
+        NW_gtk_border_set_from_border( aDefBorder, pBorder );
+        gtk_border_free( pBorder );
+    }
+    else NW_gtk_border_set_from_border( aDefBorder, &aDefDefBorder );
+
+    x = aAreaRect.Left();
+    y = aAreaRect.Top();
+    w = aAreaRect.GetWidth();
+    h = aAreaRect.GetHeight();
+
+    // If the button is too small, don't ever draw focus or grab more space
+    if ( (w < 16) || (h < 16) )
+        bDrawFocus = FALSE;
+
+    if ( (nState & CTRL_STATE_DEFAULT) && bDrawFocus )
+    {
+        x -= aDefBorder.left;
+        y -= aDefBorder.top;
+        w += aDefBorder.left + aDefBorder.right;
+        h += aDefBorder.top + aDefBorder.bottom;
+    }
 
     aRect = Rectangle( Point( x, y ), Size( w, h ) );
 
-	return( aRect );
+    return( aRect );
 }
 
 //-------------------------------------
@@ -1319,15 +1324,15 @@
                                       const ImplControlValue& aValue,
                                       const OUString& )
 {
-	GtkStateType	stateType;
-	GtkShadowType	shadowType;
-	BOOL			isChecked = (aValue.getTristateVal()==BUTTONVALUE_ON);
+    GtkStateType    stateType;
+    GtkShadowType   shadowType;
+    BOOL            isChecked = (aValue.getTristateVal()==BUTTONVALUE_ON);
     gint            x, y;
-    GdkRectangle	clipRect;
+    GdkRectangle    clipRect;
    
-	NWEnsureGTKButton( m_nScreen );
-	NWEnsureGTKRadio( m_nScreen );
-	NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
+    NWEnsureGTKButton( m_nScreen );
+    NWEnsureGTKRadio( m_nScreen );
+    NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
 
     gint indicator_size;
     gtk_widget_style_get( gWidgetData[m_nScreen].gRadioWidget, "indicator_size", &indicator_size, (char *)NULL);
@@ -1335,22 +1340,22 @@
     x = rControlRectangle.Left() + (rControlRectangle.GetWidth()-indicator_size)/2;
     y = rControlRectangle.Top() + (rControlRectangle.GetHeight()-indicator_size)/2;
     
-	// Set the shadow based on if checked or not so we get a freakin checkmark.
-	shadowType = isChecked ? GTK_SHADOW_IN : GTK_SHADOW_OUT;
-	NWSetWidgetState( gWidgetData[m_nScreen].gRadioWidget, nState, stateType );
-	NWSetWidgetState( gWidgetData[m_nScreen].gRadioWidgetSibling, nState, stateType );
+    // Set the shadow based on if checked or not so we get a freakin checkmark.
+    shadowType = isChecked ? GTK_SHADOW_IN : GTK_SHADOW_OUT;
+    NWSetWidgetState( gWidgetData[m_nScreen].gRadioWidget, nState, stateType );
+    NWSetWidgetState( gWidgetData[m_nScreen].gRadioWidgetSibling, nState, stateType );
 
-	// GTK enforces radio groups, so that if we don't have 2 buttons in the group,
-	// the single button will always be active.  So we have to have 2 buttons.
+    // GTK enforces radio groups, so that if we don't have 2 buttons in the group,
+    // the single button will always be active.  So we have to have 2 buttons.
     
     // #i59666# set the members directly where we should use
     // gtk_toggle_button_set_active. reason: there are animated themes
     // which are in active state only after a while leading to painting
     // intermediate states between active/inactive. Let's hope that
     // GtkToggleButtone stays binary compatible.
-	if (!isChecked)
-		GTK_TOGGLE_BUTTON(gWidgetData[m_nScreen].gRadioWidgetSibling)->active = TRUE;
-	GTK_TOGGLE_BUTTON(gWidgetData[m_nScreen].gRadioWidget)->active = isChecked;
+    if (!isChecked)
+        GTK_TOGGLE_BUTTON(gWidgetData[m_nScreen].gRadioWidgetSibling)->active = TRUE;
+    GTK_TOGGLE_BUTTON(gWidgetData[m_nScreen].gRadioWidget)->active = isChecked;
 
     for( clipList::const_iterator it = rClipList.begin(); it != rClipList.end(); ++it )
     {
@@ -1364,7 +1369,7 @@
                           x, y, indicator_size, indicator_size );
     }
     
-	return( TRUE );
+    return( TRUE );
 }
 
 //-------------------------------------
@@ -1377,15 +1382,15 @@
                                       const ImplControlValue& aValue,
                                       const OUString& )
 {
-	GtkStateType	stateType;
-	GtkShadowType	shadowType;
-	BOOL			isChecked = (aValue.getTristateVal()==BUTTONVALUE_ON) ? TRUE : FALSE;
-    GdkRectangle	clipRect;
-    gint			x,y;
+    GtkStateType    stateType;
+    GtkShadowType   shadowType;
+    BOOL            isChecked = (aValue.getTristateVal()==BUTTONVALUE_ON) ? TRUE : FALSE;
+    GdkRectangle    clipRect;
+    gint            x,y;
 
-	NWEnsureGTKButton( m_nScreen );
-	NWEnsureGTKCheck( m_nScreen );
-	NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
+    NWEnsureGTKButton( m_nScreen );
+    NWEnsureGTKCheck( m_nScreen );
+    NWConvertVCLStateToGTKState( nState, &stateType, &shadowType );
 
     gint indicator_size;
     gtk_widget_style_get( gWidgetData[m_nScreen].gCheckWidget, "indicator_size", &indicator_size, (char *)NULL);
@@ -1393,10 +1398,10 @@
     x = rControlRectangle.Left() + (rControlRectangle.GetWidth()-indicator_size)/2;
     y = rControlRectangle.Top() + (rControlRectangle.GetHeight()-indicator_size)/2;
     
-	// Set the shadow based on if checked or not so we get a checkmark.
-	shadowType = isChecked ? GTK_SHADOW_IN : GTK_SHADOW_OUT;
-	NWSetWidgetState( gWidgetData[m_nScreen].gCheckWidget, nState, stateType );
-	GTK_TOGGLE_BUTTON(gWidgetData[m_nScreen].gCheckWidget)->active = isChecked;
+    // Set the shadow based on if checked or not so we get a checkmark.
+    shadowType = isChecked ? GTK_SHADOW_IN : GTK_SHADOW_OUT;
+    NWSetWidgetState( gWidgetData[m_nScreen].gCheckWidget, nState, stateType );
+    GTK_TOGGLE_BUTTON(gWidgetData[m_nScreen].gCheckWidget)->active = isChecked;
 
     for( clipList::const_iterator it = rClipList.begin(); it != rClipList.end(); ++it )
     {
@@ -1410,17 +1415,17 @@
                          x, y, indicator_size, indicator_size );
     }
 
-	return( TRUE );
+    return( TRUE );
 }
 
 //-------------------------------------
 static void NWCalcArrowRect( const Rectangle& rButton, Rectangle& rArrow )
 {
-	// Size the arrow appropriately
+    // Size the arrow appropriately
     Size aSize( rButton.GetWidth()/2, rButton.GetHeight()/2 );
     rArrow.SetSize( aSize );
 
-	rArrow.SetPos( Point(
+    rArrow.SetPos( Point(
         rButton.Left() + ( rButton.GetWidth()  - rArrow.GetWidth()  ) / 2,
         rButton.Top() + ( rButton.GetHeight() - rArrow.GetHeight() ) / 2
         ) );
